<template>
  <!--
    The tooltip for this element needs to live on a wrapping div
    because disabled buttons don't send events to the DOM (so
    the hover leave will never trigger if the user's mouse leaves
    the button while it's loading.)
  -->
  <div
    v-b-tooltip.hover.v-primary
    :title="tooltip"
  >
    <b-button
      :disabled="!isAuthenticated || submitting"
      class="p-0"
      size="sm"
      variant="outline"
      @click="toggleFavorite"
    >
      <div v-if="favorited">
        <font-awesome-icon
          v-if="!submitting"
          :style="{ color: 'gray' }"
          icon="star"
        />
        <font-awesome-icon
          v-else
          :style="{ color: 'gray' }"
          icon="star"
          pulse
        />
      </div>
      <div v-else>
        <div v-if="!submitting">
          <font-awesome-layers>
            <font-awesome-icon
              :style="{ color: 'gray' }"
              icon="star"
            />
            <font-awesome-icon
              :style="{ color: 'white' }"
              icon="star"
              transform="shrink-6"
            />
          </font-awesome-layers>
        </div>
        <div v-else>
          <font-awesome-layers>
            <font-awesome-icon
              :style="{ color: 'gray' }"
              icon="star"
              pulse
            />
            <font-awesome-icon
              :style="{ color: 'white' }"
              icon="star"
              pulse
              transform="shrink-6"
            />
          </font-awesome-layers>
        </div>
      </div>
    </b-button>
  </div>
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue';
import { mapGetters } from 'vuex';

import { Locus, LocusAnnotation } from '@/common/types';
import { CREATE_OR_UPDATE_LOCUS_ANNOTATION } from '@/store/actions';

export default Vue.extend({
  props: {
    locus: {
      type: Object,
      required: true,
    } as PropOptions<Locus>,
  },

  data() {
    return {
      // Originally `favorited` was handled as a computed property. The update logic
      // broke after we moved the create/update locus annotation flow into
      // the store so the component is now responsible for tracking this state.
      favorited: false,
      submitting: false,
    };
  },

  computed: {
    ...mapGetters(['user', 'isAuthenticated', 'userData']),
    annotation(): LocusAnnotation | null {
      return this.userData.locusAnnotations[this.locus.id] || null;
    },
    tooltip(): string {
      if (!this.isAuthenticated) {
        return 'Login to save this locus';
      } if (this.submitting) {
        return 'Saving...';
      }
      return this.favorited ? 'Remove from favorites' : 'Add to favorites';
    },
  },

  mounted() {
    this.favorited = this.annotation ? this.annotation.favorited : false;
  },

  methods: {
    async toggleFavorite() {
      this.submitting = true;
      try {
        await this.$store.dispatch(CREATE_OR_UPDATE_LOCUS_ANNOTATION, {
          locusId: this.locus.id,
          locusAnnotation: { favorited: !this.favorited },
        });
        this.favorited = !this.favorited;
        this.$emit(this.favorited ? 'favorited' : 'unfavorited');
      } finally {
        this.submitting = false;
      }
    },
  },
});
</script>
